package com.academiaandroid.autenticacion;

//Ejemplo aplicacin Android que permite sincronizar automticamente 
//con una base de datos remota, de manera peridica, usando un Sync Adapter
//
//academiaandroid.com
//
//by Jos Antonio Gzquez Rodrguez


import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;

import android.graphics.Color;
import android.os.AsyncTask;
import android.view.View;
import android.widget.TextView;
import android.widget.Toast;

//Clase que hereda de AsyncTask, que nos permite ejecutar un hilo en segundo plano, independiente
//del hilo de la UI.
public class TareaAsincrona extends AsyncTask<Void, Integer, String>{

	private View rootView;
	private MainActivity context;
	private TextView txtDatos;
	
	public TareaAsincrona(View rootView, MainActivity context){
	    this.rootView = rootView;
	    this.context = context;
	}
	
	//Mtodo que se ejecutar en un hilo diferente al de la interfaz de usuario, 
	//donde se definen los parmetros para establecer la conexin con el servidor remoto.
	@Override
	protected String doInBackground(Void... params) {

		//Se declaran e inicializan los datos de conexin con el servidor remoto Postgres.
		String conexion = "jdbc:postgresql://192.168.1.129:5434/Concesionario";
 		String usuario = "postgres";
 		String password = "jose110904";
 		String datos = null;
 		String id = null;
 		String marca = null;
 		String modelo = null;
 		java.sql.Connection conn = null;
 		java.sql.Statement st = null;
 		ResultSet rs = null;
 		
 	 try {
 		 	//Cargamos el driver del conector JDBC del servidor Postgres.
 		 	Class.forName("org.postgresql.Driver");
 		 	//Establecemos la conexin con el Servidor Postgres indicndole como parmetros la url construida,
    		//la Base de Datos a la que vamos a conectarnos, y el usuario y contrasea de acceso al servidor
 		 	conn = DriverManager.getConnection(conexion,usuario,password);
 		 	//Se realiza una consulta Transact-SQL para mostrar todos los vehculos almacenados.
	   	 	String stsql = "Select * from lista_coches";
	   	 	st = conn.createStatement();
	   	 	//Se ejecutar la consulta inicializada anteriormente.
	   	 	rs = st.executeQuery(stsql); 	 
	   	 	
	   	 	//Mostramos el ltimo registro de la consulta ejecutada.
 	 		while(rs.next())
 	 		{
 	 			System.out.println(rs.getString("_id"));
 	 			id = rs.getString("_id");
 	 			System.out.println(rs.getString("marca"));
 	 			marca = rs.getString("marca");
 	 			System.out.println(rs.getString("modelo"));
 	 			modelo = rs.getString("modelo");
 	 			if(isCancelled())
 	 		 	{
 	 		        break;
 	 		 	}
 	 		}
 	 		
 	 		datos = "|ID: " + id + "|| Marca: " + marca + "|| Modelo: " + modelo + "|"; 	 		 	 	
 	 	}
 	 	 catch (SQLException se) 
	   	 {
	   	 	System.out.println("Error al conectar con la base de datos: " + se.getMessage());
	   	 }
 		 catch (ClassNotFoundException e) 
	   	 {
	   		 	System.out.println("No se encuentra la clase. Error: " + e.getMessage());
	   	 }
	 	 finally
	 	 {
	 		 	try {
	 		 		//Cerramos las conexiones abiertas, independientemente de si se ha producido un error o no.
					conn.close();
					st.close();
			 		rs.close();
				} catch (SQLException e) {
					e.printStackTrace();
				}		 		
	 	 }
		return datos;
	}
	
	//Mostramos los registros devueltos por la consulta en el hilo principal de la aplicacin.
	@Override
	public void onPostExecute(String result)
    {
		if(result != null)
		{
			Toast.makeText(context, "Mostrando datos del sistema", Toast.LENGTH_LONG).show();
	        txtDatos = (TextView)context.findViewById(R.id.txtDatos);
	        txtDatos.setTextColor(Color.RED);
	        txtDatos.setText(result);
		}else
		{
			Toast.makeText(context, "La consulta no ha producido resultados", Toast.LENGTH_LONG).show();
	        txtDatos = (TextView)rootView.findViewById(R.id.txtDatos);
	        txtDatos.setTextColor(Color.RED);
	        txtDatos.setText("Sin resultados");
		}
    }
	
	//Mtodo que cierra el hilo secundario y por lo tanto cierra la conexin.
	@Override
    protected void onCancelled() {
        Toast.makeText(context, "Conexin detenida con Servidor Remoto.",Toast.LENGTH_SHORT).show();        
    }
}
